#ifndef __ERRORS_H
#define __ERRORS_H

#ifdef __cplusplus
extern "C" {
#endif

#define ASSERT_CRITICAL 1
#define ASSERT_NON_CRITICAL 0

void fw_assert_func(int assert_num, int is_critical);

#define FW_ASSERT(expr, assert_num, critical) \
    do { \
        if (expr) { \
            fw_assert_func(assert_num, critical); \
        } \
    } while (0)

/* !!! BEWARE !!! DO NOT CHANGE THE ORDER! */
typedef enum {
    CLOCK_INIT_ASSERT_0 = 0,
    CLOCK_INIT_ASSERT_1,
    CLOCK_INIT_ASSERT_2,
    CLOCK_INIT_ASSERT_3,
    CLOCK_INIT_ASSERT_4,

    RTC_INIT_ASSERT_5 = 5,
    RTC_INIT_ASSERT_6,
    RTC_INIT_ASSERT_7,
    RTC_INIT_ASSERT_8,
    RTC_INIT_ASSERT_9,

    SPI3_INIT_ASSERT_10 = 10,
    SPI3_INIT_ASSERT_11,
    SPI3_INIT_ASSERT_12,
    SPI3_INIT_ASSERT_13,
    SPI3_INIT_ASSERT_14,

    TIM2_INIT_ASSERT_15 = 15,
    TIM2_INIT_ASSERT_16,
    TIM2_INIT_ASSERT_17,
    TIM2_INIT_ASSERT_18,
    TIM2_INIT_ASSERT_19,

    TIM3_INIT_ASSERT_20 = 20,
    TIM3_INIT_ASSERT_21,
    TIM3_INIT_ASSERT_22,
    TIM3_INIT_ASSERT_23,
    TIM3_INIT_ASSERT_24,

    UART1_INIT_ASSERT_25 = 25,
    UART1_INIT_ASSERT_26,
    UART1_INIT_ASSERT_27,
    UART1_INIT_ASSERT_28,
    UART1_INIT_ASSERT_29,

    TIM10_INIT_ASSERT_30 = 30,
    TIM10_INIT_ASSERT_31,
    TIM10_INIT_ASSERT_32,
    TIM10_INIT_ASSERT_33,
    TIM10_INIT_ASSERT_34,

    ERR_THREAD_CREATION_ASSERT_500 = 500,
    ERR_THREAD_CREATION_ASSERT_501,
    ERR_THREAD_CREATION_ASSERT_502,
    ERR_THREAD_CREATION_ASSERT_503,
    ERR_THREAD_CREATION_ASSERT_504,

    /********************************/
    /* NO INIT ASSERTS AND WARNINGS */
    /********************************/

    LCD_PWM_START_ASSERT_1000 = 1000,
    LCD_PWM_START_ASSERT_1001,
    LCD_PWM_START_ASSERT_1002,
    LCD_PWM_START_ASSERT_1003,
    LCD_PWM_START_ASSERT_1004,

    ENGINES_PWM_START_ASSERT_1005 = 1005,
    ENGINES_PWM_START_ASSERT_1006,
    ENGINES_PWM_START_ASSERT_1007,
    ENGINES_PWM_START_ASSERT_1008,
    ENGINES_PWM_START_ASSERT_1009,

    LCD_SPI_TRANSFER_ASSERT_1010 = 1010,
    LCD_SPI_TRANSFER_ASSERT_1011,
    LCD_SPI_TRANSFER_ASSERT_1012,
    LCD_SPI_TRANSFER_ASSERT_1013,
    LCD_SPI_TRANSFER_ASSERT_1014,

    LCD_LVGL_ASSERT_1015 = 1015,
    LCD_LVGL_ASSERT_1016,
    LCD_LVGL_ASSERT_1017,
    LCD_LVGL_ASSERT_1018,
    LCD_LVGL_ASSERT_1019,
} errors_t;

#ifdef __cplusplus
}
#endif

#endif /* __ERRORS_H */
